#include "main.h"
#include "parameters.h"

int main (int argc, char** argv)
{
	char filename[] = "carlin_blow_it.wav";
	//char mark[] = "abalantxa" ;
	char mark[] = "hola" ;
	WaveData mainVoice = {0,0,NULL};
	int result;
	WAVHeader header;
	unsigned short * where, *initialWhere;


	FILE * fdWAV;
	/* Loading the voice from the file */
	if (argc > 1)
	{
//		result = loadVoice (&mainVoice,&header,argv[1]);
		if ((fdWAV = openWAV(argv[1],"rb",&header,0)) == NULL)
		{
			return 0;
		}

		printf ("file in opened\n");
	}
	else
	{
		//result = loadVoice (&mainVoice,&header,filename);
		if ((fdWAV = openWAV(filename,"rb",&header,0)) == NULL)
		{
			return 0;
		}
	}
	unsigned length = getLength(fdWAV);
	printf ("length is %d: \n",length);
	unsigned allLen = length;
	length = length/(MARK_SAMPLES*2);
	

	FILE * outWAV = openWAV("marked.wav", "w", &header, length*(MARK_SAMPLES*2));
	if (outWAV == NULL)
	{
		return 1;
	}
	printf ("file out opened\n");

	DWT_INIT();

	short* data = (short*)malloc(sizeof(short)*MARK_SAMPLES);
	if (!data)
		return 0;

	long i;
	unsigned len;
	char k=7;
	for (i=0;i<length;i++)
	{
		len = readWAV(fdWAV, MARK_SAMPLES*2, (void*)data);

		if (i==100 || i == 10 || i==500)
		//if (i == 0)
		{
			putSynMark (data+MARK_SAMPLES-SYN_NSAMPLES);
/*			if (testSynMark(data+MARK_SAMPLES-SYN_NSAMPLES) == 0)
			{
				printf ("marka encontrada! :)\n");
			}*/
/*			printf ("posicion: %d\n",i*MARK_SAMPLES); */
		}
		if (i==101 || i == 11 || i==501)
		//if (i == 1)
		{
			printf ("hidden: %ld\n",k);
			embedMethod (data,k);
		//	unsigned long extracted = extractMethod (data);
		//	printf ("hidden: %08x && extracted = %08x -> %s\n", k, extracted, k==extracted?"OK":"NOK");
			
			k*=4;
		}

		len = saveWAV(outWAV, MARK_SAMPLES*2, (void*)data);
	}

	if (data)
		free(data);

	closeWAV(&fdWAV);
	closeWAV(&outWAV);

	printf ("PROCESS ENDED OK!!!\n");

	return 0;
}


