#include "logarithmic.h"


double data2[MARK_SAMPLES];
double approx2[MARK_SPEC_HALF_SAMPLES],detail2[MARK_SPEC_HALF_SAMPLES];

//void hideBit (float *spectrum, int n, short bit)
void hideBit (double *spectrum, const unsigned short aBit)
{
	int i=0;
	float sign = 1;
	float elevator;
	float to_add=0;
	unsigned short bit;

	if (aBit <=0) bit = 0;
	else  bit = 1;

//	printf ("hide %d\n",bit);
	
	to_add = ((float)bit) * LOG_DELTA / 2.0;

//	printf ("to_add = %f\n", to_add);
	
//printf ("BLOCK NEXT\n");
	for (i=0;i<MARK_SPEC_SAMPLES_PER_BIT;i++)
	{
		if (spectrum[i] < 0) sign = -1;
		else sign = 1;
//	printf ("sign = %f", sign);

//		printf ("\n init: %f\n",spectrum[i]);
		elevator = fabs(spectrum[i]);

		elevator *= LOG_SCALE;
//		printf ("\n elevator1: %f\n",elevator);
		elevator = log10(elevator);
//		printf ("\n elevator2: %f\n",elevator);
		elevator /= LOG_DELTA;
//		printf ("\n elevator3: %f\n",elevator);
		elevator = (int)elevator;
//		printf ("\n elevator4: %f\n",elevator);
		elevator *= LOG_DELTA;
//		printf ("\n delta: %f\n",LOG_DELTA);
//		printf ("\n elevator5: %f\n",elevator);
		elevator +=to_add;

//		printf ("\n elevator6: %f\n",elevator);
		elevator = ((float)pow(10.00,elevator));

		elevator /= LOG_SCALE;

		//spectrum[i] = sign * ((float)pow (10.00, elevator));
		spectrum[i] = sign * elevator;
//		printf ("  end: %f\n",spectrum[i]);
//printf ("spectrum[%d]<=%lf\n",i,spectrum[i]);
	}
}

void getHidenBit (const double *spectrum, unsigned short * bit)
{
	int i=0;
	//int sign = 1;
	int zeroCount=0, oneCount = 0;
	float rounded, common, result;

//printf ("BLOCK NEXT\n");
	for (i=0;i<MARK_SPEC_SAMPLES_PER_BIT;i++)
	{
//printf ("spectrum[%d]<=%lf\n",i,spectrum[i]);
	//	printf ("\n extracter: %f\n",spectrum[i]);
		common = fabs(spectrum[i]);
		common *= LOG_SCALE;
		common = log10(common);
		common *= LOG_DELTA;
/*		#if ARQ_x86
		rounded = round (common);
		#else*/
		//#error com faig round???
		rounded = (int)(common+0.5);
//		#endif

		common = fabs(common);

		result = fabs(common - rounded);

	//	printf ("common = %f\n",common);
	//	printf ("rounded = %f\n",rounded);
//		printf ("result = %f\n",result);

		if (result < 0.250 ) 
			zeroCount++;
		else 
			oneCount++;
	}

	//printf ("zeroCount: %d\n",zeroCount);
	//printf ("oneCount: %d\n",oneCount);

	if (zeroCount > oneCount)
		*bit = 0;
	else
		*bit = 1;

	//printf ("get %d\n",*bit);
}

